;---------------------------------
;FILE:		THERMISTOR V01.ASM
;AUTHOR:		WATER.LEE
;COMPANY:		HYCON TEK
;DEVICE:		HY11P32
;INPUT:		Sensor: SS133-303H394DL6090.pdf, PT1.0, PT1.1
;OUTPUT:		LCD, BZ
;CREATED:		2009/5/27  08:12:07
;UPDATED:		2009/6/14  10:45:04
;DESCRIP:		MAIN CODE
;TPYE:		CONFIDENTIAL
;			BIEṩУ32(64WORD)
;			resolution: 0.01C, Accuracy: 0.05C
;			VDD>2.6V, VDDA=2.4V mode
;			Sensor: SS133-303H394DL6090.pdf
;OPERATION:
;			ǰPT1.0Уģʽ
;			BIEһWORDΪհʱԶУģʽ
;			ԶУģʽ:
;				ȡ10ݣ͵һʱȽʱ96HΧڣʼжϣ10ʶ96HΧڣһΪУֵ¼BIEж
;				ȽʱADOΪ[(+) - (-)]/2 λжϣH=02H, M=01111XXXHŻԶУжģʽȡֵ
;				VPPû6VУʱʾWAVPPѶϢ
;			ʹ37Cο29938.5RУ,Уɺ¿ʼ
;			32CʾOVRL43CʾOVRH
;			ģʽУPT1.0TIMERAסԼ4~5ֵʾH xxxxBZ ON
;			ٰPT1.0صģʽ
;			PT1.1ʾʷ¼¶ֵʾr xxxx
;			ٰPT1.1صģʽ	
;			PT1.0/PT1.1OVRL/OVRH޶
;			PT1.2˯ģʽ,ٰPT1.0ỽѾƬصģʽ
;---------------------------------                     
	INCLUDE	MACRO.mac

ORG   0000H
	JMP		BEGIN
ORG   0004H
	INCLUDE  	INTERRUPT.ASM

BEGIN:
MAINLOOP:
	CALL		SysInit
	CALL		SHOW321
	BTSZ		INTF1,E0IF,A		;ǰPT1.0ֱӽУģʽ; УֵΪ29938.5R
	JMP		400MVCAL		
	JMP		READCALDARF2
;**********************************
;==================================
;		ʼв
;==================================
;**********************************
400MV:
	BTSZ		INTF1,E0IF,A
	CALL		TIMERASTART
	BTSZ		INTF1,E1IF,A
	JMP		SHOWRECORD
	
	CLRF		ADGIVECN,A		;ʵֵ
	MVL		004H
	MVF		ADFLAG,F,A		;ȡƽֵ
	BCF		INTF1,ADCIF,A
	BSF		INTE1,GIE,A
	BSF		INTE1,ADCIE,A
	
400MV_1:
	BTSS		ADGIVECN,7,A
	JMP		400MV_1

GET400ADP:
	TFSZ		ADFLAG,A
	JMP		GET400ADP
	BCF		INTE1,ADCIE,A

	CALL		AVERAGEADO		;4ƽ
     
	mvffsplus     	ADBG+6,ADA0+0	;4ֵƽ
      mvffsplus     	ADBG+7,ADA0+1
      mvffsplus     	ADBG+8,ADA0+2
							
	MVL		01011110b			;, VR=AI2-AI3
      MVF     	AINET2,F,ACCE		; INX:INH=SI-, INL=SI+

	CLRF		ADGIVECN,A		;ʵֵ
	MVL		004H
	MVF		ADFLAG,F,A		;ȡƽֵ
	BCF		INTF1,ADCIF,A
	BSF		INTE1,ADCIE,A
400MV_2:
	BTSS		ADGIVECN,7,A
	JMP		400MV_2
GET400ADN:
	TFSZ		ADFLAG,A
	JMP		GET400ADN
	BCF		INTE1,ADCIE,A
	
	CALL		AVERAGEADO		;4ƽ

	CALL		NETCHANGE			;,VR=AI2-AI3  INX:INH=SI+, INL=SI-
	CLRF		ADGIVECN,A

	CALL		POSNE			;(+)-(-)

	CALL		ADOSHIFT			;λadoĽ

	TFSZ		ADBF,A			;Уʱжȡڼ4ƽ
	RET

GAINCAL:

	CALL		GAINMATH			;LCDʾADֵ
							;(Actual ADO * REF R) / (УѹµADO)
							;RESULT AT TEMP+1, TEMP
	
;======START TO LOOKUP TABLE=======		
	CLRF		STATUS			;8F70 H = 36720 D
	MVL		8FH
	MVF		AH,F,ACCE
	MVL		70H
	MVF		AL,F,ACCE
	MVF		TEMP,W,ACCE
	SUBF		AL,F,ACCE
	MVF		TEMP+1,W,ACCE
	SUBC		AH,F,ACCE
	
	MVFFS		AL,Temp+3
	MVFFS		AH,Temp+4
	
	BTSS		STATUS,C,ACCE
	JMP		SHOWLOWLIMIT
	
	CLRF		STATUS			;5E70 H = 24176 D
	MVL		5EH
	MVF		BH,F,ACCE
	MVL		70H
	MVF		BL,F,ACCE
	MVFFS		TEMP,CL
	MVFFS		TEMP+1,CH
	MVF		BL,W,ACCE
	SUBF		CL,F,ACCE
	MVF		BH,W,ACCE
	SUBC		CH,F,ACCE
	
	BTSS		STATUS,C,ACCE
	JMP		SHOWHIGHLIMIT
	
	MVL		07H
	MVF		ACOUNT,F,ACCE				
	
STARTTABLE:
	BCF		STATUS,C,ACCE
	RRFC		AH,F,ACCE
	RRFC		AL,F,ACCE
	DCSZ		ACOUNT,F,ACCE
	JMP		STARTTABLE
	
	CLRF		STATUS
	RLFC		AL,F,ACCE
	
	MVFFS		AL,TABBUF
	CALL		SEARCHR
	MVF		T1_L,F,ACCE
	
	INF		TABBUF,F,ACCE
	CALL		SEARCHR
	MVF		T1_H,F,ACCE
	
	INF		TABBUF,F,ACCE
	CALL		SEARCHR
	MVF		T2_L,F,ACCE
	
	INF		TABBUF,F,ACCE
	CALL		SEARCHR
	MVF		T2_H,F,ACCE	
	
	
;========= T2-T1 ===========
	MVFFS		T2_H,BH
	MVFFS		T2_L,BL
	MVFFS		T1_H,CH
	MVFFS		T1_L,CL

	CLRF		STATUS
	MVF		CL,W,ACCE
	SUBF		BL,F,ACCE
	MVF		CH,W,ACCE
	SUBC  	BH,F,ACCE
;============================
	
;========== DIFFERENCE ==========
	CLRF		Temp+4
	MVL		01111111B
	ANDF		Temp+3,F,ACCE		;DIFFERENCE
;================================
	
;===== (T2-T1)*DIFFERENCE ========
	MVL		BL				;λַ
	MVF		MD1,F,ACCE
	MVL		Temp+3			;λַ
	MVF		MD2,F,ACCE
	MVL		RESULT0			;λַ
	MVF		MD3,F,ACCE
	MVL		02H				;
	MVF		MDL1,F,ACCE
	MVL		01H				;
	MVF		MDL2,F,ACCE
	CALL		MULTIPLY
;==================================

;===== (T2-T1)*DIFFERENCE/128 =====
	MVL		80H
	MVF		BL,F,ACCE
	MVL		RESULT0
	MVF		MD1,F,ACCE
	MVL		BL
	MVF		MD2,F,ACCE
	MVL		Temp
	MVF		MD3,F,ACCE
	MVL		02H
	MVF		MDL1,F,ACCE
	MVL		01H
	MVF		MDL2,F,ACCE
	MVL		02H
	MVF		MDL3,F,ACCE
	CALL		DIVIDE45
;===================================

;==== T1+(T2-T1)*DIFFERENCE/128 ====
	MVF		T1_L,W,ACCE
	ADDF		Temp,F,ACCE
	MVF		T1_H,W,ACCE
	ADDC		Temp+1,F,ACCE
	
	;ADDF		TEMP,F,A
	;ADDC		TEMP+1,F,A		;16RESULT| TEMP+1,TEMP+0

	MVL		002H
	MVF		DSP+5,F,ACCE		;Сʾڵڼλ
								
	BTSZ		HOLDMODE,BHOLD,A	;жǷtimerAжʱߢȡֵ; 1:ȡֵ; 0:	
	CALL		MAXVALUE

ENDGAINCAL:
	CALL		SHOWADC			;LCDʾ

ENDSHOW:

	CLRF		ADBF,A
	CLRF		ADGIVECN,A		;ad giveup COUNTER,лֵ
	CALL		CLRADBF			;AD BFڵֵ
	
	BTSS		PT1,bit2,ACCE           ;жǷ˯ģʽ
	JMP		MainSleep
	
	BTSZ		HOLDMODE,BMAX,A	;1:ʾֻʾֵ; 0:
	CALL		HOLDMODESEL
	NOP
	
	BCF		LCD0,BIT7,A		;ֵ
	JMP		400MV
	NOP

HOLDMODESEL:
	CALL		DELAY100MS
	BCF		PT1M2,BIT6,A
	IDLE
	NOP
RET
;----------------------------------
;************************
;----------------------------------


SHOWRECORD:
	BTSS		PT1,BIT1,A
	JMP		SHOWRECORD
	CALL		DELAY100MS
	BTSS		PT1,BIT1,A
	JMP		SHOWRECORD
	MVFFS	MAXL1,TEMP
	MVFFS	MAXH1,TEMP+1
	MVL		002H
      MVF		DSP+5,F,ACCE		;Сʾڵڼλ
	MVL		LCDNUMR			;R
	MVF		LCD0,F,A			;ʾ¼ֵ
	CALL		SHOWADC
	BCF		TMACN,ENTMA,A
	CLRF		INTF1,A
	BSF		INTE1,E1IE,A
	IDLE
	NOP
	CLRF		ADBF,A
	CLRF		ADGIVECN,A		;ad giveup COUNTER,лֵ
	CALL		CLRADBF			;AD BFڵֵ
	JMP		400MV
	
TIMERASTART:
	BSF		HOLDMODE,BHOLD,A	;жǷtimerAжʱߢȡֵ; 1:ȡֵ; 0:	
	BTSS		PT1,BIT0,A
	JMP		TIMERASTART
	CALL		DELAY100MS
	BTSS		PT1,BIT0,A
	JMP		TIMERASTART
	BSF		LCD0,BIT7,A		;׼¼ֵ
	BCF		INTF1,E0IF,A
	BSF		TMACN,ENTMA,A
	CLRF		TMAR,A
	BCF		INTF1,TMAIF,A
RET

MAXVALUE:
	BTGF		LCD0,BIT7,A		
	MVF		TEMP+0,W,A
	SUBF		MAXL,W,A
	MVF		TEMP+1,W,A
	SUBC		MAXH,W,A
	MVL		0
	SUBC		TEMP+2,W,A
	TFSZ		WREG,A
	JMP		MAXVALUE_
	JMP		MAXVALUE_1
MAXVALUE_:	
	MVFFS	TEMP+1,MAXH
	MVFFS	TEMP+0,MAXL
MAXVALUE_1:
	BTSS		INTF1,TMAIF,A
	RET
	BCF		TMACN,ENTMA,A
	CLRF		INTF1,A
	
	MVFFS	MAXH,TEMP+1
	MVFFS	MAXL,TEMP+0
	BSF		HOLDMODE,BMAX,A	;1:ʾֻʾֵ; 0:
	BCF		HOLDMODE,BHOLD,A	;жǷtimerAжʱߢȡֵ; 1:ȡֵ; 0:	
	BSF		INTE1,E0IE,A
	MVL		LCDNUMH			;H
	MVF		LCD0,F,A			;¼ֵ
	BSF		PT1M2,BIT6,A		;BZ ENABLE
	
RET	
				
;**********************************
;==================================
;		У
;==================================
;**********************************
400MVCAL:
	BTSS		PT1,BIT0,A
	JMP		400MVCAL
	NOP

STARTCAL400MV:
	CLRF		LCD0,A
	MVL		LCDNUMC			;C
	MVF		LCD1,F,A
	MVL		LCDNUMA			;A
	MVF		LCD2,F,A
	MVL		LCDNUM3			;3
	MVF		LCD3,F,A
	MVL		LCDNUM0			;0
	MVF		LCD4,F,A
	MVL		LCDNUMK			;K
	MVF		LCD5,F,A
	BSF		LCD5,7,A			;display g to show calibrating

	BTSS		PT1,BIT0,A
	JMP		STARTCAL400MV
	CALL		DELAY100MS
	BTSS		PT1,BIT0,A
	JMP		STARTCAL400MV
	CALL		DELAY100MS
	CLRF		INTF1,A

STARTCAL400MV_1:	
	MVL		02				;Уʱȡ4ƽֵ				
	MVF		ADBF,F,A
	CALL		NETCHANGE			;Ԥл
CALGAIN400MV:
	BTGF		LCD5,7,A			;display g to show calibrating
     CALL		400MV
	DCSZ		ADBF,F,A
	JMP		CALGAIN400MV
	BCF		INTE1,GIE,A
	CLRF		ADGIVECN,A

	MVF		HOLDMODE,W,A
	ANDL		00FH
	TFSZ		WREG,A			;жԶУģʽ
	JMP		CALCHK
	JMP		WAITVPP
	
CALCHK:
	MVL		002H				;ж027xH
	CPSE		TEMP+2,A
	JMP		STARTCAL400MV_1
	MVF		TEMP+1,W,A
	ANDL		11111000B
	MVF		ADShM+1,F,A
	MVL		070H
	CPSE		ADShM+1,A
	JMP		STARTCAL400MV_1
	
	BTGF		LCD0,BIT7,A		;ʾ. жѭ
	MVL		10				;жǷһ
	CPSL		HOLDMODE,A
	JMP		FIRSTDATA
	
	MVF		TEMP,W,A			;ж/
	CPSG		STABLEL,A
	JMP		STALTEMP
	
	MVF		TEMP,W,A
	SUBF		STABLEL,W,A
	MVF		ADShM+1,F,A
	MVL		096H				;жǷ<96H(150COUNT)
	CPSL		ADShM+1,A
	JMP		CLEARDATA
	JMP		FIRSTDATA_1
	
STALTEMP:
	MVF		STABLEL,W,A
	SUBF		TEMP,W,A
	MVF		ADShM+1,F,A
	MVL		096H				;жǷ<96H(150COUNT)


	CPSL		ADShM+1,A
	JMP		CLEARDATA

CLEARDATA:
	MVL		10
	MVF		HOLDMODE,F,A		;βȶԶУģʽ
	JMP		STARTCAL400MV_1	;ԶУ
	
FIRSTDATA:
	MVFFS	TEMP,STABLEL
FIRSTDATA_1:
	DCF		HOLDMODE,F,A
	JMP		STARTCAL400MV_1

;For BIE Write Data----------------
WAITVPP:
	BTSZ		BIECTRL,VPP_HIGH,A	;CHECK VPP VOLTAGE
	JMP		SEARCHSTART
	CALL		SHOWVPP
	JMP		WAITVPP
	
SEARCHSTART:	
	CALL		ClearLCD			
	BSF		LCD5,7,A			;дУֵ
	MVL		0				;SEARCH BLANKBIE
	MVF		BIEPTRL,F,ACCE		;EPROMλΪ00H
SEARCHBIE:	
	BSF		BIECTRL,BIERD,A	;ָȡEPROMݴڻTBLDH, TBLDL
	MVF		BIEDH,W,A			;ȷǷհ?
	ANDF		BIEDL,W,A
	SUBL		0FFH
	TFSZ		WREG,A
	JMP		CHKPOINT
	JMP		ENDSEARCHBIE	
CHKPOINT:
	MVF		BIEPTRL,W,A
	SUBL		03FH
	TFSZ		WREG,A
	JMP		SEARCHBIE
	TFSZ		WREG,A
	JMP		ENDSEARCHBIE
	CALL		SHOWFULL			;BIE FULL
	IDLE
	NOP
ENDSEARCHBIE:
	DCF		BIEPTRL,F,ACCE		;EPROMλΪ
	MVL		05AH				;д[TBLDH,TBLDL], DATA START:5AH
	MVF		BIEDH, F, ACCE			
	MVF		TEMP+2,W,A		;DATA|0F2H,0F1H,0F0H			
	MVF		BIEDL, F, ACCE			
	BSF		BIECTRL,BIEWR,A	;(1)TBLCTRL[VPP_HIGH]=0TBLPTRL3FH  ָЧ
							;(2)TBLCTRL[VPP_HIGH]=1TBLPTRLQ3FH  ָЧ
							;EPROMȡ/дɺTBLCTRL[BIEWR]ԶΪ0
							;TBLPTRLԶ3FH
	CALL		WAITWR
	MVF		TEMP+1,W,A		;д[TBLDH,TBLDL]
	MVF		BIEDH, F, ACCE			
	MVF		TEMP+0,W,A						
	MVF		BIEDL, F, ACCE			
	BSF		BIECTRL,BIEWR,A	;(1)TBLCTRL[VPP_HIGH]=0TBLPTRL3FH  ָЧ
	CALL		WAITWR	
;END BIE Write Data----------------
;;==================================
;;		У
;;==================================
;;**********************************
	BCF		ADCCN1,ENADC,A
	CLRF		PWRCN,A
	JMP		BEGIN			;׼ʼ



WAITWR:
	BTSZ		BIECTRL,BIEWR,A	;WAIT TO WRITE
	JMP		WAITWR		
RET

;**********************************
;==================================
;		ȡEEPROMУֵ
;==================================
;**********************************
;*******REGN=1/2,VR=VDDA-VSS,******
;---400mV eepromУֵ---
READCALDARF2:
	MVL		001H
	MVF		MODESEL,F,A
	BCF		LCD5,7,A			;disable g
	BCF		INTE1,ADCIE,A
	BTSS		PT1,BIT0,A
	JMP		READCALDARF2

BYPASSRDEE_:	
;For BIE Read Data----------------
	MVL		0				;SEARCH BLANKBIE
	MVF		BIEPTRL,F,ACCE		;EPROMλΪ00H
	BSF		BIECTRL,BIERD,A		;ָȡEPROMݴڻTBLDH, TBLDL
	MVF		BIEDH,W,A			;ȷǷհ?
	ANDF		BIEDL,W,A
	SUBL		0FFH
	TFSZ		WREG,A
	JMP		SEARCHBIE1
	JMP		400MVCAL			;ԶУģʽ
SEARCHBIE1:	
	BSF		BIECTRL,BIERD,A		;ָȡEPROMݴڻTBLDH, TBLDL
	MVL		03FH				;ȷǷΪλ
	CPSE		BIEPTRL,A
	JMP		SEARCHBIE1_
	JMP		CHKPOINT1
SEARCHBIE1_:
	MVF		BIEDH,W,A			;ȷǷհ?
	ANDF		BIEDL,W,A
	SUBL		0FFH
	TFSZ		WREG,A
	JMP		SEARCHBIE1
	
	MVL		2
	SUBF		BIEPTRL,F,A			;EPROMλΪ
CHKPOINT1:
	DCF		BIEPTRL,F,A			;EPROMλΪ
ENDSEARCHBIE1:
	BSF		BIECTRL,BIERD,A		;ָȡEPROMݴڻTBLDH, TBLDL
							;EPROMȡ/дɺTBLCTRL[BIERD]ԶΪ0
							;TBLPTRLԶ3FH
	CALL		WAITRD
	MVL		05AH
	CPSE		BIEDH,A
	CALL		ShowCFAIL
	NOP	
RDBIE:	
	MVF		BIEDL,W,A
	MVF		Adspan+2,F,A
	BSF		BIECTRL,BIERD,A	;ָȡEPROMݴڻTBLDH, TBLDL
							;EPROMȡ/дɺTBLCTRL[BIERD]ԶΪ0
							;TBLPTRLԶ3FH
	CALL		WAITRD
	MVF		BIEDH,W,A
	MVF		Adspan+1,F,A
	MVF		BIEDL,W,A
	MVF		Adspan+0,F,A
	
;END BIE Read Data----------------

	CALL		CALAD			;gainֵ

BYPASSRDEE:	
	CALL		NETCHANGE			;л
	CALL		DELAY10MS
	BCF		INTF1,E0IF,A
	BCF		INTF1,E1IF,A
	JMP		400MV
;*********EEPROM END***************
WAITRD:
	BTSZ		BIECTRL,BIERD,A	;WAIT TO READ
	JMP		WAITRD		
RET
	
;==================================
;	  ȡEEPROMУֵ
;==================================
;**********************************

CALAD:
	MVL		0F2H				;29938.5 COUNT(R) @ 37C
	MVF		CWeight+0,F,A
	MVL		074H
	MVF		CWeight+1,F,A
	CLRF		CWeight+2,A
	CLRF		ADBF,A
RET


NETCHANGE:
	 mvl     01000110b			;
       mvf     AINET2,F,ACCE		; VRH=AI2, VRL=AI3
       						; VRH[6:5]=00, AI10
       						; 		 01, AI8
       						; 		 10, AI2
       						;		 11, REFO
       						; VRL[2:1]=00, AI11
       						;		 01, AI9
       						;		 10, AI3
       						;		 11, VSS

       						; INX[4:3]=00, INH=SI+, INL=SI-
       						;		 01, INL=SI+, INL=SI-
       						;		 10, INH=SI+, INH=SI-
       						;		 11, INH=SI-, INL=SI+
RET

POSNE:
	MVF		ADBG+6,W,A		;(+)-(-)
	SUBF		ADA0+0,F,A
	MVF		ADBG+7,W,A
	SUBC		ADA0+1,F,A
	MVF		ADBG+8,W,A
	SUBC		ADA0+2,F,A
	
	BCF		STATUS,C,A
	RRFC		ADA0+2,F,A		;/2
	RRFC		ADA0+1,F,A
	RRFC		ADA0+0,F,A
	mvffsplus		ADA0+2,ADShM+2
	mvffsplus		ADA0+1,ADShM+1
	mvffsplus		ADA0+0,ADShM+0
RET

SEARCHR:
	MVL		HIGH	RTABLE		
	MVF		PCLATH,F,A
	MVF		TABBUF,W,A
	ADDL    	LOW	RTABLE		; Ծֵ TABLEλǷ񳬹0x100
	BTSS    	STATUS,C,ACCE
	JMP     	RPRE
	INF     	PCLATH,F,ACCE		; 0x100 [PCLATU,PCLATH] + 1
RPRE:    
	MVL	     LOW	RTABLE
	ADDF    	TABBUF,W,ACCE
	MVF     	PCLATL,F,ACCE		; ǰPCLATL + Ծֵ
	NOP
		
ADOSHIFT:
	BCF		STATUS,C,A		;ADO OV Bitȥ,Ʋ
	RLFC     	ADShM+0,F,A
	RLFC		ADShM+1,F,A
	RLFC		ADShM+2,F,A
	BTSZ		STATUS,C,A
	BSF		ADShM+2,7,A
	CLRF		ADATEMP,A
	BTSZ		ADShM+2,7,A
	INF		ADATEMP,F,A

	MVL		04
	INF		WREG,W,A			;DUMMY BITƳ
	MVF		GIVEBIT,F,A		;bitݣADOܹȡ+/-18BIT DATA
SHIFTADO:						;nADO
	RRFC		ADATEMP,F,A
	RRFC		ADShM+2,F,A
	RRFC		ADShM+1,F,A
	RRFC		ADShM+0,F,A
	MVL		00H
	BTSZ		STATUS,C,A
	MVL		0FFH
	DCF		GIVEBIT,F,A
	RRFC		WREG,W,A
	TFSZ		GIVEBIT,A
	JMP		SHIFTADO

     BCF     	ADCFG,B_NEG,ACCE
     BTSS    	ADShM+2,BIT2,ACCE	;SIGN BIT CHECK
     JMP     	SHIFTADO_
     BSF     	ADCFG,B_NEG,ACCE
     COMF    	ADShM,F,ACCE
     COMF    	ADShM+1,F,ACCE
     COMF    	ADShM+2,F,ACCE
     MVL     	1
     ADDF   	ADShM,F,ACCE
     MVL     	0
     ADDC    	ADShM+1,F,ACCE
     MVL     	0
     ADDC    	ADShM+2,F,ACCE
SHIFTADO_:
	MVL		00000111B			;ڱεADOH MSB 5bit
	ANDF		ADShM+2,F,A
	mvffsplus		ADShM+0,TEMP+0
	mvffsplus		ADShM+1,TEMP+1
	mvffsplus		ADShM+2,TEMP+2
RET

AVERAGEADO:

	BCF		STATUS,C,A		;ȡ4ƽ
	CLRF		ADBG+12
	MVF		ADBG+9,W,A		;3BYTE ADBG+10SShM; BUFFER 1
	ADDF		ADBG+0,F,A
	MVF		ADBG+10,W,A
	ADDC		ADBG+1,F,A
	MVF		ADBG+11,W,A
	ADDC		ADBG+2,F,A
	BTSZ		STATUS,C,A
	INF		ADBG+12,F,A
	BCF		STATUS,C,A

	MVF		ADBG+0,W,A		;3BYTE ADBG+10SShM; BUFFER 2
	ADDF		ADBG+3,F,A
	MVF		ADBG+1,W,A
	ADDC		ADBG+4,F,A
	MVF		ADBG+2,W,A
	ADDC		ADBG+5,F,A
	BTSZ		STATUS,C,A
	INF		ADBG+12,F,A
	BCF		STATUS,C,A

	MVF		ADBG+3,W,A		;3BYTE ADBG+10SShM; BUFFER 3

	ADDF		ADBG+6,F,A
	MVF		ADBG+4,W,A
	ADDC		ADBG+7,F,A
	MVF		ADBG+5,W,A
	ADDC		ADBG+8,F,A
	BTSZ		STATUS,C,A
	INF		ADBG+12,F,A
	BCF		STATUS,C,A

	RRFC		ADBG+12,F,A		;/4
	RRFC		ADBG+8,F,A		;ֵƽ
	RRFC		ADBG+7,F,A
	RRFC		ADBG+6,F,A
	RRFC		ADBG+12,F,A
	RRFC		ADBG+8,F,A		;ֵƽ
	RRFC		ADBG+7,F,A
	RRFC		ADBG+6,F,A
	
RET
	
GAINMATH:
       mvl      Temp			;ַ, New AD
       mvf      md1,F,ACCE
       mvl      CWeight			;ַ, УõĲοֵ 
       mvf      md2,F,ACCE
       mvl      Temp+3			;ַ
       mvf      md3,F,ACCE
       mvl      3
       mvf      mdl1,F,ACCE
       mvl      3
       mvf      mdl2,F,ACCE
       call     multiply
       
       mvffs     Adspan,temp+9	;οµУADCֵ
       mvffs     Adspan+1,temp+9+1
       mvffs     Adspan+2,temp+9+2
	  
	  mvl      Temp+3			;
       mvf      md1,F,ACCE
       mvl     temp+9			;, 
       mvf     md2,F,ACCE
       mvl     temp				;RESULT
       mvf     md3,F,ACCE
       mvl     6
       mvf     mdl1,F,ACCE
       mvl     3
       mvf     mdl2,F,ACCE
       mvl     3
       mvf     mdl3,F,ACCE
       call    divide45
RET

SHOWADC:
	  LDPR1	 TEMP,1			;16λ
       LDPR0    TEMP+7,0		;	;10λŵط
       
       MVL     2				;2BYTEת16->10
       CALL    HTOB    
       MVL     LCD1
       MVF     DSP+1,F,ACCE
       LDPR0   TEMP+7,0		;
       MVL     5
       MVF     DSP+3,F,ACCE		;LCDʾλ
       MVL     HIGH  LCD1
       ;IORL    0F0H   ; DON'T DROUP OUT ZERO
       IORL    000H
       MVF     DSP+4,F,ACCE		;ʾСǰ0
	  CALL    DISPLAY     
    	   
RET


CLRADBF:
	CLRF		ADBG+0,A
	CLRF		ADBG+1,A
	CLRF		ADBG+2,A
	CLRF		ADBG+3,A
	CLRF		ADBG+4,A

	CLRF		ADBG+5,A
	CLRF		ADBG+6,A
	CLRF		ADBG+7,A
	CLRF		ADBG+8,A
	CLRF		ADBG+9,A
	CLRF		ADBG+10,A
	CLRF		ADBG+11,A
	CLRF		ADBG+12,A
RET

MainSleep:
	BTSS		PT1,bit2,ACCE
	JMP		MainSleep
	CALL		Delay10ms
	BTSS		PT1,bit2,ACCE
	JMP		MainSleep
	CALL		ClearLCD
	CALL		ADCENONSTEP
	BSF		INTE1,E0IE,A
	BSF		SleepFlag,INFlag,A
	
	MVL		02H
	MVF		MCKCN2,F,ACCE
	MVL		00H
	MVF		MCKCN1,F,ACCE
	MVL		00H
	MVF		MCKCN3,F,ACCE

	CLRF		ADCCN1,ACCE
	CLRF		ADCCN2,ACCE
	CLRF		ADCCN3,ACCE
	CLRF		LCDCN1,ACCE
	CLRF		PWRCN,ACCE
	CLRF		TMACN,ACCE
	MVL		00000000B
	MVF		PT1,F,ACCE
	MVL		00000000B
	MVF		TRISC1,F,ACCE
	MVL		11111111B
	MVF		PT1PU,F,ACCE
	CLRF		PT1M1,ACCE
	CLRF		PT1M2,ACCE
	CLRF		PT2,ACCE
	MVL		00000000B
	MVF		TRISC2,F,ACCE
	MVL		11111111B
	MVF		PT2PU,F,ACCE
	SLP
	NOP
Main_Sleep:
	JMP		BEGIN
	

ADCENONSTEP:
	BCF		ADCCN1,ENADC,ACCE
	MVL		7
ADCENONSTEPLOOP:
	BSF		ADCCN1,ENADC,ACCE
	BCF		ADCCN1,ENADC,ACCE
	DCSZ		WREG,F,ACCE
	JMP		ADCENONSTEPLOOP
	RET


RTABLE:
	RETL		08CH		;00		;(36720)D	(8F70)H		;00
	RETL		00CH		;01		
	RETL		094H		;02		;(36592)D	(8EF0)H		;01
	RETL		00CH		;03		
	RETL		09BH		;04		;(36464)D	(8E70)H		;02
	RETL		00CH		;05		
	RETL		0A2H		;06		;(36336)D	(8DF0)H		;03
	RETL		00CH		;07		
	RETL		0A8H		;08		;(36208)D	(8D70)H		;04
	RETL		00CH		;09		
	RETL		0B0H		;0A		;(36080)D	(8CF0)H		;05
	RETL		00CH		;0B		
	RETL		0BCH		;0C		;(35952)D	(8C70)H		;06
	RETL		00CH		;0D		
	RETL		0C7H		;0E		;(35824)D	(8BF0)H		;07
	RETL		00CH		;0F		
	RETL		0D0H		;10		;(35696)D	(8B70)H		;08
	RETL		00CH		;11		
	RETL		0D7H		;12		;(35568)D	(8AF0)H		;09
	RETL		00CH		;13		
	RETL		0E0H		;14		;(35440)D	(8A70)H		;0A
	RETL		00CH		;15		
	RETL		0E8H		;16		;(35312)D	(89F0)H		;0B
	RETL		00CH		;17		
	RETL		0F0H		;18		;(35184)D	(8970)H		;0C
	RETL		00CH		;19		
	RETL		0F9H		;1A		;(35056)D	(88F0)H		;0D
	RETL		00CH		;1B		
	RETL		002H		;1C		;(34928)D	(8870)H		;0E
	RETL		00DH		;1D		
	RETL		00AH		;1E		;(34800)D	(87F0)H		;0F
	RETL		00DH		;1F		
	RETL		013H		;20		;(34672)D	(8770)H		;10
	RETL		00DH		;21		
	RETL		01CH		;22		;(34544)D	(86F0)H		;11
	RETL		00DH		;23		
	RETL		025H		;24		;(34416)D	(8670)H		;12
	RETL		00DH		;25		
	RETL		02EH		;26		;(34288)D	(85F0)H		;13
	RETL		00DH		;27		
	RETL		038H		;28		;(34160)D	(8570)H		;14
	RETL		00DH		;29		
	RETL		040H		;2A		;(34032)D	(84F0)H		;15
	RETL		00DH		;2B		
	RETL		049H		;2C		;(33904)D	(8470)H		;16
	RETL		00DH		;2D		
	RETL		051H		;2E		;(33776)D	(83F0)H		;17
	RETL		00DH		;2F		
	RETL		05BH		;30		;(33648)D	(8370)H		;18
	RETL		00DH		;31		
	RETL		064H		;32		;(33520)D	(82F0)H		;19
	RETL		00DH		;33		
	RETL		06DH		;34		;(33392)D	(8270)H		;1A
	RETL		00DH		;35		
	RETL		076H		;36		;(33264)D	(81F0)H		;1B
	RETL		00DH		;37		
	RETL		07FH		;38		;(33136)D	(8170)H		;1C
	RETL		00DH		;39		
	RETL		089H		;3A		;(33008)D	(80F0)H		;1D
	RETL		00DH		;3B		
	RETL		092H		;3C		;(32880)D	(8070)H		;1E
	RETL		00DH		;3D		
	RETL		09CH		;3E		;(32752)D	(7FF0)H		;1F
	RETL		00DH		;3F		
	RETL		0A6H		;40		;(32624)D	(7F70)H		;20
	RETL		00DH		;41		
	RETL		0AFH		;42		;(32496)D	(7EF0)H		;21
	RETL		00DH		;43		
	RETL		0B7H		;44		;(32368)D	(7E70)H		;22
	RETL		00DH		;45		
	RETL		0C1H		;46		;(32240)D	(7DF0)H		;23
	RETL		00DH		;47		
	RETL		0CAH		;48		;(32112)D	(7D70)H		;24
	RETL		00DH		;49		
	RETL		0D5H		;4A		;(31984)D	(7CF0)H		;25
	RETL		00DH		;4B		
	RETL		0DEH		;4C		;(31856)D	(7C70)H		;26
	RETL		00DH		;4D		
	RETL		0E9H		;4E		;(31728)D	(7BF0)H		;27
	RETL		00DH		;4F		
	RETL		0F2H		;50		;(31600)D	(7B70)H		;28
	RETL		00DH		;51		
	RETL		0FAH		;52		;(31472)D	(7AF0)H		;29
	RETL		00DH		;53		
	RETL		005H		;54		;(31344)D	(7A70)H		;2A
	RETL		00EH		;55		
	RETL		00EH		;56		;(31216)D	(79F0)H		;2B
	RETL		00EH		;57		
	RETL		018H		;58		;(31088)D	(7970)H		;2C
	RETL		00EH		;59		
	RETL		022H		;5A		;(30960)D	(78F0)H		;2D
	RETL		00EH		;5B		
	RETL		02DH		;5C		;(30832)D	(7870)H		;2E
	RETL		00EH		;5D		
	RETL		037H		;5E		;(30704)D	(77F0)H		;2F
	RETL		00EH		;5F		
	RETL		041H		;60		;(30576)D	(7770)H		;30
	RETL		00EH		;61		
	RETL		04CH		;62		;(30448)D	(76F0)H		;31
	RETL		00EH		;63		
	RETL		056H		;64		;(30320)D	(7670)H		;32
	RETL		00EH		;65		
	RETL		063H		;66		;(30192)D	(75F0)H		;33
	RETL		00EH		;67		
	RETL		06BH		;68		;(30064)D	(7570)H		;34
	RETL		00EH		;69		
	RETL		074H		;6A		;(29936)D	(74F0)H		;35
	RETL		00EH		;6B		
	RETL		07EH		;6C		;(29808)D	(7470)H		;36
	RETL		00EH		;6D		
	RETL		089H		;6E		;(29680)D	(73F0)H		;37
	RETL		00EH		;6F		
	RETL		094H		;70		;(29552)D	(7370)H		;38
	RETL		00EH		;71		
	RETL		09EH		;72		;(29424)D	(72F0)H		;39
	RETL		00EH		;73		
	RETL		0AAH		;74		;(29296)D	(7270)H		;3A
	RETL		00EH		;75		
	RETL		0B3H		;76		;(29168)D	(71F0)H		;3B
	RETL		00EH		;77		
	RETL		0BEH		;78		;(29040)D	(7170)H		;3C
	RETL		00EH		;79		
	RETL		0C9H		;7A		;(28912)D	(70F0)H		;3D
	RETL		00EH		;7B		
	RETL		0D4H		;7C		;(28784)D	(7070)H		;3E
	RETL		00EH		;7D		
	RETL		0E0H		;7E		;(28656)D	(6FF0)H		;3F
	RETL		00EH		;7F		
	RETL		0EAH		;80		;(28528)D	(6F70)H		;40
	RETL		00EH		;81		
	RETL		0F6H		;82		;(28400)D	(6EF0)H		;41
	RETL		00EH		;83		
	RETL		001H		;84		;(28272)D	(6E70)H		;42
	RETL		00FH		;85		
	RETL		00DH		;86		;(28144)D	(6DF0)H		;43
	RETL		00FH		;87		
	RETL		019H		;88		;(28016)D	(6D70)H		;44
	RETL		00FH		;89		
	RETL		024H		;8A		;(27888)D	(6CF0)H		;45
	RETL		00FH		;8B		
	RETL		033H		;8C		;(27760)D	(6C70)H		;46
	RETL		00FH		;8D		
	RETL		03DH		;8E		;(27632)D	(6BF0)H		;47
	RETL		00FH		;8F		
	RETL		046H		;90		;(27504)D	(6B70)H		;48
	RETL		00FH		;91		
	RETL		053H		;92		;(27376)D	(6AF0)H		;49
	RETL		00FH		;93		
	RETL		05FH		;94		;(27248)D	(6A70)H		;4A
	RETL		00FH		;95		
	RETL		06BH		;96		;(27120)D	(69F0)H		;4B
	RETL		00FH		;97		
	RETL		079H		;98		;(26992)D	(6970)H		;4C
	RETL		00FH		;99		
	RETL		081H		;9A		;(26864)D	(68F0)H		;4D
	RETL		00FH		;9B		
	RETL		08EH		;9C		;(26736)D	(6870)H		;4E
	RETL		00FH		;9D		
	RETL		098H		;9E		;(26608)D	(67F0)H		;4F
	RETL		00FH		;9F		
	RETL		0A3H		;A0		;(26480)D	(6770)H		;50
	RETL		00FH		;A1		
	RETL		0B4H		;A2		;(26352)D	(66F0)H		;51
	RETL		00FH		;A3		
	RETL		0C0H		;A4		;(26224)D	(6670)H		;52
	RETL		00FH		;A5		
	RETL		0CBH		;A6		;(26096)D	(65F0)H		;53
	RETL		00FH		;A7		
	RETL		0D6H		;A8		;(25968)D	(6570)H		;54
	RETL		00FH		;A9		
	RETL		0E3H		;AA		;(25840)D	(64F0)H		;55
	RETL		00FH		;AB		
	RETL		0F0H		;AC		;(25712)D	(6470)H		;56
	RETL		00FH		;AD		
	RETL		0FBH		;AE		;(25584)D	(63F0)H		;57
	RETL		00FH		;AF		
	RETL		008H		;B0		;(25456)D	(6370)H		;58
	RETL		010H		;B1		
	RETL		014H		;B2		;(25328)D	(62F0)H		;59
	RETL		010H		;B3		
	RETL		022H		;B4		;(25200)D	(6270)H		;5A
	RETL		010H		;B5		
	RETL		02FH		;B6		;(25072)D	(61F0)H		;5B
	RETL		010H		;B7		
	RETL		03CH		;B8		;(24944)D	(6170)H		;5C
	RETL		010H		;B9		
	RETL		046H		;BA		;(24816)D	(60F0)H		;5D
	RETL		010H		;BB		
	RETL		056H		;BC		;(24688)D	(6070)H		;5E
	RETL		010H		;BD		
	RETL		065H		;BE		;(24560)D	(5FF0)H		;5F
	RETL		010H		;BF		
	RETL		072H		;C0		;(24432)D	(5F70)H		;60
	RETL		010H		;C1		
	RETL		07CH		;C2		;(24304)D	(5EF0)H		;61
	RETL		010H		;C3		
	RETL		088H		;C4		;(24176)D	(5E70)H		;62
	RETL		010H		;C5		
	RETL		000H
	RETL		000H

;==================================
	INCLUDE   SYSINI.ASM
	INCLUDE	DISPLAY.ASM	       	
	INCLUDE	MATH.ASM
	INCLUDE	H08.INC
	INCLUDE	MAIN.INC
	INCLUDE	LCDINDX.ASM
	INCLUDE	SUBROUTINE.ASM
;==================================

    END  
